<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear Picture Show plugin.
# Copyright (c) 2008 Anne-Cécile Calvot. All rights reserved.
#
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# ***** END LICENSE BLOCK *****

$dir_name = 'picturesShow';

/* Permet d'afficher la parametrisation de la galerie */
$_menu['Blog']->addItem(
	__('Pictures Show galleries'),
	'plugin.php?p='.$dir_name.'&type=blog',
	'index.php?pf='.$dir_name.'/icon.png',
	preg_match('/plugin.php\?p='.$dir_name.'(&.*)?$/',$_SERVER['REQUEST_URI']),
	psConf::getIfActif() && $core->auth->check('media,media_admin,admin',$core->blog->id)
);

/* Permet d'afficher la parametrisation du plugins dans le menu
 * et la documentation */
$_menu['Plugins']->addItem(
	__('Pictures Show'),
	'plugin.php?p='.$dir_name.'&type=plugin',
	'index.php?pf='.$dir_name.'/icon.png',
	preg_match('/plugin.php\?p='.$dir_name.'(&.*)?$/',$_SERVER['REQUEST_URI']),
	$core->auth->isSuperAdmin()
);

if (psConf::getIfActif()) {
	/* Affiche la saisie de la galerie dans le formulaire du post*/
	$core->addBehavior('adminPostForm',array('psMetaData','showDir'));

	/* Sauvegarder les données mise dans le post */
	$core->addBehavior('adminAfterPostCreate',array('psMetaData','saveMetadataRep'));
	$core->addBehavior('adminAfterPostUpdate',array('psMetaData','saveMetadataRep'));
}
/* Lorsque qu'un post est effacé, avant l'appel et la vérif des droits,
 * $core->callBehavior('adminPostsActions',$core,$posts,$action,$redir);
 * est appelé. Mais c'est la base qui fait les effacements en cascade et
 * supprime les meta data rataché à celui-ci.
 * */  
?>
