<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear Picture Show plugin.
# Copyright (c) 2008 Anne-Cécile Calvot. All rights reserved.
#
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# ***** END LICENSE BLOCK *****
#-----------------------------------------------------------
# Adds a new behavior
#-----------------------------------------------------------
if (psConf::getIfActif()) {
	$core->addBehavior('publicBeforeDocument',array('behaviorPicturesShow','addTplPath'));
	$core->addBehavior('publicHeadContent',array('behaviorPicturesShow','pictureShowCssHeadContent'));
	$core->addBehavior('publicHeadContent',array('behaviorPicturesShow','publicCssHeadContent'));
}
$core->addBehavior('templateBeforeBlock',array('behaviorPicturesShow','postBeforeBlock'));
$core->addBehavior('templateBeforeBlock',array('behaviorPicturesShow','homeBeforeBlock'));
$core->addBehavior('publicHeadContent',array('behaviorPicturesShow','publicJsHeadContent'));

class behaviorPicturesShow
{
	public static function addTplPath(&$core)
	{
		$core->tpl->setPath($core->tpl->getPath(), dirname(__FILE__).'/default-templates');
	}

	/* Grosse inspiration de lightbox */
	public static function publicJsHeadContent(&$core)
	{
		if (!$core->blog->settings->lightbox_enabled) {
			return;
		}
		/* si le module n'existe pas, return l'ensemble des modules */
		$mod_lightbox = $core->plugins->getModules('lightbox');
		if (!isset($mod_lightbox['version'])) {
			return;
		}
		
		if ($mod_lightbox['version'] == "1.0") {
			$url = $core->blog->getQmarkURL().'pf=lightbox';
			
			$css = "/css/jquery.lightbox-0.5.css";
			$js = "/js/jquery.lightbox-0.5.js";
			
			$imageLoading_name = "imageLoading";
			$imageBtnPrev_name = "imageBtnPrev";
			$imageBtnNext_name = "imageBtnNext";
			$imageBtnClose_name = "imageBtnClose";
			$imageBlank_name = "imageBlank";
			
			$imageLoading="/images/lightbox-ico-loading.gif";
			$imageBtnPrev="/images/prev-btn.png";
			$imageBtnNext="/images/next-btn.png";
			$imageBtnClose="/images/close-btn.png";
			$imageBlank="/images/lightbox-blank.gif";
			
			$funtion_name="lightBox";
		}
		else {
			$url = $core->blog->getQmarkURL().'pf=lightbox';
			
			$css = "/css/modal.css";
			$js = "/js/modal.js";
			
			$imageLoading_name = "loader_img";
			$imageBtnPrev_name = "prev_img";
			$imageBtnNext_name = "next_img";
			$imageBtnClose_name = "close_img";
			$imageBlank_name = "blank_img";
			
			$imageLoading="/img/loader.gif";
			$imageBtnPrev="/img/prev.png";
			$imageBtnNext="/img/next.png";
			$imageBtnClose="/img/close.png";
			$imageBlank="/img/blank.gif";
			
			$funtion_name="modalImages";
		}
		
		echo
		'<style type="text/css">'."\n".
		'@import url('.$url.$css.');'."\n".
		"</style>\n".
		'<script type="text/javascript" src="'.$url.$js.'"></script>'."\n".
		'<script type="text/javascript">'."\n".
		"//<![CDATA[\n".
		'$(function() {'."\n".
			'var lb_settings = {'."\n".
				$imageLoading_name."  : '".html::escapeJS($url).$imageLoading."',\n".
				$imageBtnPrev_name."  : '".html::escapeJS($url).$imageBtnPrev."',\n".
				$imageBtnNext_name."  : '".html::escapeJS($url).$imageBtnNext."',\n".
				$imageBtnClose_name." : '".html::escapeJS($url).$imageBtnClose."',\n".
				$imageBlank_name."    : '".html::escapeJS($url).$imageBlank."'\n".
			"};\n".
			'$("div.pictures-div").each(function() {'."\n".
					'$(this).find("a[href$=.jpg],a[href$=.jpeg],a[href$=.png],a[href$=.gif],'.
					'a[href$=.JPG],a[href$=.JPEG],a[href$=.PNG],a[href$=.GIF]").'.$funtion_name.'(lb_settings);'."\n".

			"})\n".
		"});\n".
		"\n//]]>\n".
		"</script>\n";
	}

	public static function pictureShowCssHeadContent(&$core)
	{
		if ($core->url->type=="picturesShow" && !psConf::getIfViewMenu()) {
			echo	"<style type=\"text/css\">\n".
						"#sidebar {\n".
					  "   display : none;\n".
						"}\n".
						"#main {\n".
					  "   width : 770px;\n".
						"}\n".
						"</style>";
		}
	}

	public static function publicCssHeadContent(&$core)
	{
		$css_pictures = "";
		if (psConf::getPostGalleryTheme() == psConf::$gallery_theme_gallery) {
			$css_pictures = "
/* squares list */
.pictures-div {
  margin: 0 0 0 0;
}
.picture-div {
  margin: 0pt 10px 10px 0pt;
  float: left;
  background: #FFF;
  padding: 0px;
}
 .last {
   border:0px solid red;
   margin: 0pt 10px 40px 0pt;
 }
 ";
		}
		else if (psConf::getPostGalleryTheme() == psConf::$gallery_theme_extrai_4) {
			$css_pictures = "
/* la partie text du lien */
#pictures div.text-link {
	 float: left;
	 margin: 0pt 10px 10px 0pt;
	 padding: 15px 0px 0px 0px;
	 height: 31px;
	 background: #FFF;
	 color: #9D9D9D;
}
#pictures div.text-link p{
	 margin: 0pt 0px 0px 0pt;
	 padding: 0px 0px 0px 0px;
}

/* squares list */
.picture-div {
  margin: 0pt 5px 5px 0pt;
  padding: 0px;
  height: 48px;
  float: left;
  background: #FFF;
}
 .last {
  margin: 0px 10px 10px 0pt;
  clear: right;
 }
";
		}
		else if (psConf::getPostGalleryTheme() == psConf::$gallery_theme_extrai_8) {
			$css_pictures = "
/* contien image + texte */
.pictures-div {
  margin: 0 0 0 0;
  width: 300px;
}

/* partie texte */
#pictures .text-div {
  margin: 0pt 10px 10px 0pt;
  padding: 20px 0 0 0;
  width: 106px;
  height: 28px;
  float: left;
  background: #FFF;
  text-align: center;
}

#pictures .text-div ul {
	margin: 0px;
	padding: 0px;
}

#pictures .text-div li {
	margin: 0px;
	padding: 0px;
	list-style-position : inside;
	list-style-image: url('".$core->blog->getQmarkURL()."pf=picturesShow/img/li.png');
}

 #pictures a {
   padding: 0px 0px 0px 18px;
 }

 #pictures a:link, #pictures a:visited {
   text-decoration: none;
 }
  
/* partie image */
div.picture-div {
  margin: 0pt 10px 10px 0pt;
  padding: 0px;
  float: left;
  width: 48px;
  height: 48px;
  background: #FFF;
}
 .last  {
   margin: 0pt 10px 40px 0pt;
 }
";
		}
		else if (psConf::getPostGalleryTheme() == psConf::$gallery_theme_extrai_10) {
			$css_pictures = "
/* contien image + texte */
.pictures-div {
  margin: 0 0 0 0;
  width: 200px;
}

 #pictures a {
   padding: 0px 0px 0px 0px;
 }

 #pictures a:link, #pictures a:visited {
   text-decoration: none;
 }

/* partie texte */
#pictures .text-div {
  margin: 0pt 2px 2px 0pt;
  padding: 20px 0 0 0;
  width: 98px;
  height: 28px;
  float: left;
  background: #FFF;
  text-align: center;
}

#pictures .text-div ul {
	margin: 0px;
	padding: 0px;
}

#pictures .text-div li {
	margin: 0px;
	padding: 0px;
	list-style-position : inside;
	list-style-image: url('".$core->blog->getQmarkURL()."pf=picturesShow/img/li.png');
}
  
/* partie image */
div.picture-div {
  margin: 0pt 2px 2px 0pt;
  padding: 0px;
  float: left;
  width: 48px;
  height: 48px;
  background: #FFF;
}
 .last  {
   margin: 0pt 10px 40px 0pt;
 }
";
		}
		else if (psConf::getPostGalleryTheme() == psConf::$gallery_theme_extrai_all) {
			$css_pictures = "
/* contien image + texte */
.pictures-div {
  margin: 0 0 0 0;
}

#pictures a {
   padding: 0px 0px 0px 18px;
}

 #pictures a:link, #pictures a:visited {
   text-decoration: none;
 }

/* partie texte */
#pictures p.see_gallery {
	background: url('".$core->blog->getQmarkURL()."pf=picturesShow/img/li.png') no-repeat 0 50%;
	margin: 0px 0 1em 0;
	padding: 0 0 0 10px;
}
  
/* partie image */
div.picture-div {
  margin: 0pt 10px 10px 0pt;
  padding: 0px;
  float: left;
  width: 48px;
  height: 48px;
}
 .last  {
   margin: 0pt 10px 40px 0pt;
 }
";
		}

		$css_presentation_gallery_party = "";
		if (psConf::getPostGalleryTheme() != "none") {
			$css_presentation_gallery_party = "";
			if (psConf::getTitleCssStyle() == psConf::$css_title_blowup) {
				$css_presentation_gallery_party = "
/* le contour */
/*#pictures { padding-top: 10px; }*/
 #pictures h3 {
	border-width: 1px 0;
	border-style: solid;
	border-color: #bfbfbf;
	background: #fbfbfb;
	padding: 5px;
	margin: 20px 0 8px 0;
	font-size: 1.2em;
}

 #comments h3{
	clear: both;
 }
 #comment-form h3 {
	clear: both;
 }";
			}
			else if (psConf::getTitleCssStyle() == psConf::$css_title_blue_silence) {
				$css_presentation_gallery_party = "
/* le contour */
#pictures { padding-top: 10px; }
 #pictures h3 {
	clear: both;
	margin: 20px 0 8px 0;
	padding: 5px;
	background: #FBFBFB;
	border: 1px solid #E8E8E8;
	border-width: 1px 0;
	font-size: 1.2em;
}

 #comments h3{
	clear: both;
 }
 #comment-form h3 {
	clear: both;
 }";
			}
		}
		
		$link_in_home = "";
		if (psConf::getTargetLink() != "none") {
			if ( psConf::getUrlPicture() == psConf::$all_pictures_picture
				|| psConf::getUrlPicture() == psConf::$gallery_picture ) {
				$url_lien = $core->blog->getQmarkURL().psConf::getUrlPicture();
			}
			else {
				$url_lien = psConf::getUrlPicture();	
			}
			$link_in_home = "
 /* lien dans home */
.all_photo {
  background: url('".$url_lien."') no-repeat 0 50%;
}";
		}
		
		echo	"
<style type=\"text/css\">".
$css_pictures.
$css_presentation_gallery_party.
$link_in_home."
 </style>

 ";
	}
	public static function postBeforeBlock(&$core,$b,$attr) {
		if ($core->url->type=="post") {
			if ($b == "EntryIf" && isset($attr['show_comments']) && $attr['show_comments']=="1") {
				
				
				$div_pictures = "
		  <div id=\"pictures\">
		    <h3>{{tpl:lang The gallery}}</h3>
		    %s
		  </div>";
				
				/*
				  <div class='pictures-div' align="center">
					<tpl:PicturesEntries>
					<div class='picture-div {{tpl:PictureIf last="last"}}' align="center">
						{{tpl:PictureEntry}}
					</div>
					</tpl:PicturesEntries>
				  </div> */
				$res_images_post = tplPicturesShow::pictureEntry(array());
				$res_images_post = "
					<div class='picture-div ".tplPicturesShow::pictureIf(array("last" => "last"))."' align=\"center\">
						".$res_images_post."
					</div>";
					
				$res_div_post = "
			  <div class='pictures-div' align=\"center\">
				".tplPicturesShow::picturesEntries(array(),$res_images_post)."
			  </div>";

				$res_div_post = sprintf($div_pictures,$res_div_post);
				$res_post = tplPicturesShow::ifPicturesEntries(array(),$res_div_post);

				/*
				<p><a href="{{tpl:GalleryURL}}">
				<tpl:PicturesEntriesrandomize="1" nb_pictures_per_page="3">
					   <div class='picture-div' align="center">
					{{tpl:PictureEntry class="picture"}}
					   </div>
				</tpl:PicturesEntries>
				<div class='picture-div' align="center">
					<img src="{{tpl:BlogThemeURL}}/img/etc48.jpg">
				</div>
				<div class='text-link'><p>{{tpl:lang see all the pictures}}</p></div>
				<div class='picture-div' align="center">
					<img src="{{tpl:BlogThemeURL}}/img/a_suivre48.jpg">
				</div>
				<tpl:PicturesEntries pictures_format="sq" randomize="1" nb_pictures_per_page="1">
					   <div class='picture-div' align="center">
						{{tpl:PictureEntry class="last"}}
					   </div>
				</tpl:PicturesEntries>
				</a></p>*/
				$premieres_images = "
					        <div class='picture-div' align=\"center\">
							".tplPicturesShow::pictureEntry(array())."
					        </div>";;
				$derniere_image = "
					        <div class='picture-div' align=\"center\">
							".tplPicturesShow::pictureEntry(array("class" => "last"))."
					        </div>";
					
				$premieres_images = tplPicturesShow::picturesEntries(
									array(	'thumbnails_format'=>'sq',
											'pictures_format'=>'sq',
											'randomize'=>"1",
											'nb_pictures_per_page'=>"3")
									,$premieres_images);
				$derniere_image = tplPicturesShow::picturesEntries(
									array(	'thumbnails_format'=>'sq',
											'pictures_format'=>'sq',
											'randomize'=>"1",
											'nb_pictures_per_page'=>"1")
									,$derniere_image);
									
				$res_images_gallery = $premieres_images."
							<div class='picture-div' align=\"center\">
								<img src=\"".$core->blog->getQmarkURL()."pf=picturesShow/img/etc48.jpg\">
							</div>
							<div class='text-link'><p>{{tpl:lang see all the pictures}}</p></div>
							<div class='picture-div' align=\"center\">
								<img src=\"".$core->blog->getQmarkURL()."pf=picturesShow/img/a_suivre48.jpg\">
							</div>".$derniere_image;
									
				$link_deb = "<a href=\"".tplPicturesShow::galleryURL(array())."\">";
				$link_fin = "</a><p style='clear: left;'>&nbsp;</p>";
					
					
					
				$res_div_gallery = "
			  <p>	
				".$link_deb.$res_images_gallery.$link_fin."	
			  </p>";
			  
					
				$res_div_gallery = sprintf($div_pictures,$res_div_gallery);
				$res_gallery = tplPicturesShow::ifPicturesEntries(array(),$res_div_gallery);

				
				/*
				    <div class='pictures-div'>
					<a href="{{tpl:GalleryURL}}">
					  <div class="text-div">
						<ul><li>{{tpl:lang see the gallery}}</li></ul>
					  </div>
					  <tpl:PicturesEntries randomize="1" pictures_format="sq"  thumbnails_format="sq" nb_pictures_per_page="8">
					  <div class='picture-div {{tpl:PictureIf last="last"}}'>{{tpl:PictureEntry}}</div>
					  </tpl:PicturesEntries>
					</a>
				    </div> */
				$res_post_list_pictures_content = "
					  <div class='picture-div ".tplPicturesShow::pictureIf(array("last" => "last"))."'>{{tpl:PictureEntry}}</div>";
					
				$res_post_extrai_8 = "
			  <div class='pictures-div'>
					<a href=\"".tplPicturesShow::galleryURL(array())."\">
					  <div class='text-div'>
						<ul><li>{{tpl:lang see the gallery}}</li></ul>
					  </div>
					  ".tplPicturesShow::picturesEntries(
									array(	'thumbnails_format'=>'sq',
											'pictures_format'=>'sq',
											"randomize"=>'1',
											"nb_pictures_per_page"=>'8',
											"nb_pictures_min"=>'8'),
									$res_post_list_pictures_content)."
					</a>
			  </div><p style='clear: left;'>&nbsp;</p>";

				$res_post_extrai_8 = sprintf($div_pictures,$res_post_extrai_8);
				$res_post_extrai_8 = tplPicturesShow::ifPicturesEntries(array(),$res_post_extrai_8);

				
				/*
				  <a href="{{tpl:GalleryURL}}">
					<div class='pictures-div'>
						<tpl:PicturesEntries pictures_format="sq" thumbnails_format="sq"  randomize="1" nb_pictures_per_page="5">
						<div class='picture-div {{tpl:PictureIf last="last"}}'>{{tpl:PictureEntry}}</div>
						</tpl:PicturesEntries>
						<div class="link-div">
							{{tpl:lang see the gallery}}
						</div>
						<tpl:PicturesEntries pictures_format="sq" thumbnails_format="sq" randomize="1" nb_pictures_per_page="5">
						<div class='picture-div {{tpl:PictureIf last="last"}}'>{{tpl:PictureEntry}}</div>
						</tpl:PicturesEntries>
					</div>
				  </a>*/
				$res_post_list_pictures_content = "
					  <div class='picture-div ".tplPicturesShow::pictureIf(array("last" => "last"))."'>{{tpl:PictureEntry}}</div>";
					
				$res_post_extrai_10 = "
			  <div class='pictures-div'>
					<a href=\"".tplPicturesShow::galleryURL(array())."\">
					  ".tplPicturesShow::picturesEntries(
									array(	'thumbnails_format'=>'sq',
											'pictures_format'=>'sq',
											"randomize"=>'1',
											"nb_pictures_per_page"=>'5',
											"nb_pictures_min"=>'5'),
									$res_post_list_pictures_content)."
					  <div class='text-div'>
						<ul><li>{{tpl:lang see the gallery}}</li></ul>
					  </div>
					  ".tplPicturesShow::picturesEntries(
									array(	'thumbnails_format'=>'sq',
											'pictures_format'=>'sq',
											"randomize"=>'1',
											"nb_pictures_per_page"=>'5',
											"nb_pictures_min"=>'5'),
									$res_post_list_pictures_content)."
					</a>
			  </div><p style='clear: left;'>&nbsp;</p>";

				$res_post_extrai_10 = sprintf($div_pictures,$res_post_extrai_10);
				$res_post_extrai_10 = tplPicturesShow::ifPicturesEntries(array(),$res_post_extrai_10);

				/*
				    <div class='pictures-div'>
					<a href="{{tpl:GalleryURL}}">
					  <div class="text-div">
						<ul><li>{{tpl:lang see the gallery}}</li></ul>
					  </div>
					  <tpl:PicturesEntries pictures_format="sq"  thumbnails_format="sq" nb_pictures_per_page="-1">
					  <div class='picture-div {{tpl:PictureIf last="last"}}'>{{tpl:PictureEntry}}</div>
					  </tpl:PicturesEntries>
					</a>
				    </div> */
				$res_post_list_pictures_content = "
					  <div class='picture-div ".tplPicturesShow::pictureIf(array("last" => "last"))."'>{{tpl:PictureEntry}}</div>";
					
				$res_post_extrai_all = "
			  <div class='pictures-div'>
					<a href=\"".tplPicturesShow::galleryURL(array())."\">
					  <p class='see_gallery'>{{tpl:lang see the gallery}}</p>
					  ".tplPicturesShow::picturesEntries(
									array(	'thumbnails_format'=>'sq',
											'pictures_format'=>'sq',
											"nb_pictures_per_page"=>'-1'),
									$res_post_list_pictures_content)."
					</a>
			  </div><p style='clear: left;'>&nbsp;</p>";

				$res_post_extrai_all = sprintf($div_pictures,$res_post_extrai_all);
				$res_post_extrai_all = tplPicturesShow::ifPicturesEntries(array(),$res_post_extrai_all);
				
				$php_code = '<?php
				if (psConf::getIfActif() && psConf::getPostGalleryTheme() == psConf::$gallery_theme_gallery) {
				?>
				'.$res_post.'
				<?php
				}
				else if (psConf::getIfActif() && psConf::getPostGalleryTheme() == psConf::$gallery_theme_extrai_4) {
				?>
				'.$res_gallery.'
				<?php
				}
				else if (psConf::getIfActif() && psConf::getPostGalleryTheme() == psConf::$gallery_theme_extrai_8) {
				?>
				'.$res_post_extrai_8.'
				<?php
				}
				else if (psConf::getIfActif() && psConf::getPostGalleryTheme() == psConf::$gallery_theme_extrai_10) {
				?>
				'.$res_post_extrai_10.'
				<?php
				}
				else if (psConf::getIfActif() && psConf::getPostGalleryTheme() == psConf::$gallery_theme_extrai_all) {
				?>
				'.$res_post_extrai_all.'
				<?php
				}
				?>';
				return $php_code;
			}
		}
	}
	
	/**
	 * Dans le home seule la direction du lien (et l'image défini dans css)  est succeptible de changer.
	 */
	public static function homeBeforeBlock(&$core,$b,$attr) {
		if ($core->url->type=="default") {
			if ($b == "EntryIf" && isset($attr['show_comments']) && $attr['show_comments']=="1"
				&& isset($attr['show_pings']) && $attr['show_pings']=="1"
				&& isset($attr['has_attachment']) && $attr['has_attachment']=="1"
				&& (isset($attr['operator']) && $attr['operator'] == "or")) {
				
				$content = '<?php $start_post_info_co = true; ?>';
				
				$res = '<?php
				if ( psConf::getIfActif()
					&&(!isset($first_tag) || $first_tag == false)) {
					// on est dans le premier if (ouverture de la balise <p class="post-info-co">)
					$first_tag = true;
				?>'.
					$core->tpl->EntryIf(array(	"show_comments" => "1",
											"show_pings" => "1",
											"has_attachment" => "1",
											"operator" => "or"),
									$content).'
				<?php
				}
				else if ( psConf::getIfActif()
						&& (isset($first_tag) && $first_tag == true)) {
					// on est dans le deuxième if (fermeture de la balise <p class="post-info-co">)
					$first_tag = false;
					$start_post_info_co = false;
				}?>';
				return $res;
				
			}
			if ($b == "EntryIf" && isset($attr['show_comments']) && $attr['show_comments']=="1"
				&& (!isset($attr['operator']) || $attr['operator'] == "")) {
				
				$start_post_code = '<?php
				if ( !isset($start_post_info_co) || $start_post_info_co == false) {
					// on a pas afficher le tag <p class="post-info-co">
				?>
		      <p class="post-info-co">
				<?php
				}
				?>';	
				$end_post_code = '<?php
				if ( !isset($start_post_info_co) || $start_post_info_co == false) {
					// on a pas afficher le tag <p class="post-info-co">
					$start_post_info_co = false;
				?>
		      </p>
				<?php
				}
				?>';		
				$lien =  "<a href=\"%s\" class=\"all_photo\"><?php echo __(\"see the gallery\");?></a>";
				
				$url_href_post = $core->tpl->EntryURL(array())."#pictures";
				$res_link_to_post = sprintf($lien,$url_href_post);
				$res_link_to_post = tplPicturesShow::ifPicturesEntries(array(),$start_post_code.$res_link_to_post.$end_post_code);

				$url_href_gallery = tplPicturesShow::galleryURL(array());
				$res_link_to_gallery = sprintf($lien,$url_href_gallery);
				$res_link_to_gallery = tplPicturesShow::ifPicturesEntries(array(),$start_post_code.$res_link_to_gallery.$end_post_code);
				
				
				$php_code = '<?php
				if (psConf::getIfActif() && psConf::getTargetLink() == psConf::$target_link_to_pstemplate) {
				?>
				'.$res_link_to_gallery.'
				<?php
				}
				else if (psConf::getIfActif() && psConf::getTargetLink() == psConf::$target_link_to_post) {
				?>
				'.$res_link_to_post.'
				<?php
				}
				?>';
				return $php_code;
				
			}
		}
	}
}

#-----------------------------------------------------------
# Add template tags 
#-----------------------------------------------------------
$core->tpl->addValue('GalleryURL',      array('tplPicturesShow','galleryURL'));
$core->tpl->addBlock('IfPicturesEntries',array('tplPicturesShow','ifPicturesEntries'));
$core->tpl->addBlock('PicturesEntries',  array('tplPicturesShow','picturesEntries'));
$core->tpl->addBlock('PicturesEntriesHeader',array('tplPicturesShow','picturesEntriesHeader'));
$core->tpl->addBlock('PicturesEntriesFooter',array('tplPicturesShow','picturesEntriesFooter'));
$core->tpl->addValue('PictureEntry',         array('tplPicturesShow','pictureEntry'));
$core->tpl->addValue('PictureEntryURL',      array('tplPicturesShow','pictureEntryURL'));
$core->tpl->addBlock('PicturesPagination',   array('tplPicturesShow','pagination'));
$core->tpl->addBlock('PicturesPaginationIf', array('tplPicturesShow','paginationIf'));
$core->tpl->addValue('PicturesPaginationCurrent', array('tplPicturesShow','paginationCurrent'));
$core->tpl->addValue('PicturesPaginationCounter', array('tplPicturesShow','paginationCounter'));
$core->tpl->addValue('PictureIf', array('tplPicturesShow','pictureIf'));

class tplPicturesShow
{
	
	private static function getFilters($attr,$current_tag)
	{
		$f = $GLOBALS['core']->tpl->getFilters($attr);
		return preg_replace("|,'[^,]*'\)$|",",'".$current_tag."')",$f);
	}
	
	/* Pictures*********************************/
	/**
	  * Le contenu ne s'affiche que s'il existe une galerie avec au moins une image qui possède les formats demandés.
	  *
	  * $attr les attributs gérés sont :
	  * <ul>
	  * 	 <li>pictures_format : Peut prendre comme valeur, sq, t, s, m et o qui correspond
	  * 	 au format square, thumbail, small, medium et original du gestionnaire des médias,
	  * 	 il peut prendre aussi les formats utilisateurs définis depuis l'administration.
	  * 	 La valeur correspond  au premier format dont ont vérifie l'existence.
	  * 	 Si l'attribut n'est pas mis ou vide, ce sera le format précisé dans l'interface d'administration
	  *	 qui sera choisi. Si la valeur est fausse rien ne s'affiche.
	  * 	 </li>
	  * 	 <li>thumbnails_format : Peut prendre comme valeur, sq, t, s, m et o qui correspond
	  * 	 au format square, thumbail, small, medium et original du gestionnaire des médias,
	  * 	 il peut prendre aussi les formats utilisateurs définis depuis l'administration.
	  * 	 La valeur correspond  au deuxième format dont ont vérifie l'existence.
	  * 	 Si l'attribut n'est pas mis ou vide, ce sera le format précisé dans l'interface d'administration
	  *	 qui sera choisi. Si la valeur est fausse rien ne s'affiche.
	  * 	 </li></ul>
	  */
	public static function ifPicturesEntries($attr,$content)
	{
		$pictures_format_id		= (isset($attr["pictures_format"]))?'"'.$attr["pictures_format"].'"':'psConf::getGalPicturesFormatId()';
		$thumbnails_format_id	= (isset($attr["thumbnails_format"]))?'"'.$attr["thumbnails_format"].'"':'psConf::getGalThumbnailsFormatId()';
		
		return
		'<?php
		if (psConf::getIfActif()) {
			try {
				$obj_meta = new dcMeta($GLOBALS["core"]);
				$rep_picture = $obj_meta->getMetaStr($_ctx->posts->post_meta,psConf::getMetaRepName());

				if (psPicturesGallery::isGallery($rep_picture,'.$pictures_format_id.','.$thumbnails_format_id.') ) {?>'.
					$content.'<?php
				}
			}
			catch (Exception $e) {
				// on ne fait rien
			}
		}
		?>';
	}

	/**
	  * Liste des images qui possèdent à la fois un format d'affichage (thumbnails_format)
	  * et un format principal (pictures_format).
	  *
	  * $attr les attributs gérés sont :
	  * <ul>
	  * 	 <li>no_content : Si à 1, désactive le parcours (la boucle) sur les images,
	  * 	 ce qui rend les attributs nb_pictures_per_page et randomize inopérants.</li>
	  * 	 <li>pictures_format : Peut prendre comme valeur, sq, t, s, m et o qui correspond
	  *	 au format square, thumbail, small, medium et original du gestionnaire des médias,
	  *	 il peut prendre aussi les formats utilisateur définis depuis l'administration.
	  *	 La valeur correspond au format d'image qui sera choisi pour les grandes images.
	  *	 Si l'attribut n'est pas mis ou vide, ce sera le format précisé dans l'interface d'administration
	  *	 qui sera choisi. Si la valeur est fausse rien ne s'affiche. </li>
	  * 	 <li>thumbnails_format : Peut prendre comme valeur, sq, t, s, m et o qui correspond
	  * 	 au format square, thumbail, small, medium et original du gestionnaire des médias,
	  * 	 il peut prendre aussi les formats utilisateur définis depuis l'administration.
	  * 	 La valeur correspond au format d'image qui sera choisi pour l'affichage des
	  * 	 images. Si la valeur est la même que pictures_format l'image ne se sera pas pas cliquable.
	  * 	 Si l'attribut n'est pas mis ou vide, ce sera le format précisé dans l'interface d'administration
	  *	 qui sera choisi. Si la valeur est fausse rien ne s'affiche. </li>
	  * 	 <li>nb_pictures_per_page : Si l'attribut n'est pas mis ou vide, ce sera
	  * 	 la valeur précisée dans l'interface d'administration
	  *	 qui sera choisi. Si à -1, affiche toutes les images sinon affiche
	  * 	 le nombre précisé d'images par page.</li>
	  * 	 <li>randomize : si à 1, affiche 'nb_pictures_per_page' images choisies alléatoirement.
	  * 	 (Créé une galerie d'une seule page)</li>
	  * 	 <li>nb_pictures_min : Actif que si le paramètre randomize est à 1.
	  * 	 Nombre minimum d'image que l'on veut voir s'afficher dans la galerie.
	  * 	 Si la galerie possède moins d'image que le nombre indiqué alors certaine image seront dupliquée.
	  * 	 Si la valeur est supérieure à nb_pictures_per_page alors l'attribu sera ignoré.</li>
	  * </ul>
	  */
	public static function picturesEntries($attr,$content)
	{
		$no_content = ( isset($attr["no_content"]) && $attr["no_content"]=="1" )?true    :false;
		if (!$no_content) {
			$boucle = '
					$_ctx->psIndexListPictures=0;
					foreach ( $_ctx->psGallery->getPicturesOfPage() as $_ctx->picture) { 
						if ( $_ctx->picture->formatExist($_ctx->psGallery->getThumbnailsFormatId()) )
						{?>'.
							$content.'<?php
						}
						{
							// augmente index de 1
							$index = 1 + $_ctx->psIndexListPictures;
							$_ctx->pop("psIndexListPictures");
							$_ctx->psIndexListPictures=$index;
						}
						$_ctx->pop("picture");
					}';
		}
		else {
			$boucle = '?>'.
					$content.'<?php';
		}
		
		$php_init_gal = '';
		
		$f = $GLOBALS['core']->tpl->getFilters($attr);

		
		$nb_pictures_per_page	= (isset($attr["nb_pictures_per_page"]))?'"'.$attr["nb_pictures_per_page"].'"':'psConf::getGalNbPicturesPerPage()';
		$pictures_format_id		= (isset($attr["pictures_format"]))?'"'.$attr["pictures_format"].'"':'psConf::getGalPicturesFormatId()';
		$thumbnails_format_id	= (isset($attr["thumbnails_format"]))?'"'.$attr["thumbnails_format"].'"':'psConf::getGalThumbnailsFormatId()';
		$nb_pictures_min		= (isset($attr["nb_pictures_min"]))?'"'.$attr["nb_pictures_min"].'"':'null';

		if(isset($attr["randomize"]) && $attr["randomize"]=="1") {
			$init_gal = 'psPicturesGallery::getRandomGallery($pictures_rep,'.$pictures_format_id.','.$thumbnails_format_id.','.$nb_pictures_per_page.','.$nb_pictures_min.')';
		}
		else {
			$init_gal = 'psPicturesGallery::getGallery($pictures_rep, $ps_page_num,'.$pictures_format_id.','.$thumbnails_format_id.','.$nb_pictures_per_page.')';
		}

		$res =
		'<?php
		if (psConf::getIfActif()) {
			try {
				$_ctx =& $GLOBALS["_ctx"];
				$ps_page_num = (isset($GLOBALS["_ps_page_number"]))?$GLOBALS["_ps_page_number"]:0;

				// ne pas mettre $GLOBALS["_ps_page_number"]=null;
				// au cas où on a deux PicturesEntries de suite
				$obj_meta = new dcMeta($GLOBALS["core"]);
				$pictures_rep = $obj_meta->getMetaStr($_ctx->posts->post_meta, psConf::getMetaRepName());
				if ($pictures_rep !== null && $pictures_rep !== "") {
					$gallery  = '.$init_gal.';
					unset($ps_page_num);

					if ($gallery->getPicturesOfPage() != null
						&& count($gallery->getPicturesOfPage()) != 0)
					{
						$_ctx->psGallery = $gallery;
						$gallery = null;'.
						$boucle.'
						$_ctx->psGallery = null;
						$_ctx->psIndexListPictures = null;
					}
				}
			}
			catch (Exception $e) {
				// on ne fait rien
			}
		}
		?>';

		return $res;
	}
  
	/**
	 * Le contenu ne sera affiché qu'à la première itération de la boucle
	 * PicturesEntries.
	 * Ce qui permet d'afficher un "pied de page" à la liste effectuée sans utiliser
	 * &lt;tpl:IfPicturesEntries&gt;.*/
	public static function picturesEntriesHeader($attr,$content)
	{
		$res = '<?php if (psConf::getIfActif() && $_ctx->psIndexListPictures == 0) { ?>'.$content.'<?php } ?>';
		return $res;
	}

	/**
	 * Le contenu ne sera affiché qu'à la dernière itération de la boucle
	 * PicturesEntries.
	 * Ce qui permet d'afficher une entête à la liste effectuée sans utiliser
	 * &lt;tpl:IfPicturesEntries&gt;.*/
	public static function picturesEntriesFooter($attr,$content)
	{
		$res = '<?php if (psConf::getIfActif() && $_ctx->psIndexListPictures == count($_ctx->psGallery->getPicturesOfPage())-1 ) { ?>'.$content.'<?php } ?>';
		return $res;
	}

	/**
	 * $attr les attributs gérés sont :
	 * <ul>
	 * 	 <li>last : si posséde une valeur, la retoune si l'image correspond
	 * 	 à la derniére image de la galerie</li>
	 * 	 <li>first : si posséde une valeur, la retoune si l'image correspond
	 * 	 à la première image de la galerie</li>
	 * </ul>
	 */
	public static function pictureIf($attr)
	{
		$res='';
		
		if (isset($attr["last"])) {
			$res .= '<?php if (psConf::getIfActif() && $_ctx->psIndexListPictures == count($_ctx->psGallery->getPicturesOfPage())-1 ) { ?>'.$attr["last"].'<?php } ?>';
		}
		if (isset($attr["first"])) {
			$res .= '<?php if (psConf::getIfActif() && $_ctx->psIndexListPictures == 0 ) { ?>'.$attr["first"].'<?php } ?>';
		}
		return $res;
	}

	/**
	 * Affiche l'image.
	 *
	 * $attr les attributs gérés sont :
	 * <ul>
	 * 	 <li>style : permet de préciser le style css à appliquer à l'image</li>
	 * 	 <li>class : permet de préciser la classe css à appliquer à l'image</li>
	 * 	 <li>link : peut prendre comme valeur : sq, t, s, m, o qui correspond
	 *   au format square, thumbail, small, medium, original du gestionnaire
	 *   des médias, il peut prendre aussi les formats utilisateurs
	 *   définis depuis l'administration.
	 *   La valeur correspond au format de l'image qui s'affiche lorsque l'on
	 *   clique sur l'image.
	 *   Si le format est vide on utilisera le format original,
	 *   s'il n'existe pas, on n'affiche pas de lien.</li>
	 * </ul>
	 */
	public static function pictureEntry($attr)
	{
		$style=(isset($attr["style"]))?"style='".$attr["style"]."'":'';
		$class=(isset($attr["class"]))?"class='".$attr["class"]."'":'';
		$display_root_url = "false";
		if(isset($attr["absolute_urls"]) && $attr["absolute_urls"] == "1") {
			$display_root_url = "true";
		}
		
		$f = self::getFilters($attr,"PictureEntry");
		
		return '
			<?php
				$code_html_href_et_img = "";
				$code_html_href = "";
				if($_ctx->psGallery->getThumbnailsFormatId() != $_ctx->psGallery->getFormatId()) {
					$code_html_href = "<a href=\"".psConf::getURLPicturesShow('.$display_root_url.').$_ctx->psGallery->getRelativRep()."/".$_ctx->picture->getThumbnailByFormatId($_ctx->psGallery->getFormatId())->getFileName()."\">%s</a>";
				}
				else {
					$code_html_href = "%s"; 
				}
				if (psConf::getIfActif() && $_ctx->picture->formatExist($_ctx->psGallery->getThumbnailsFormatId())) {
				
					$code_html_img = "<img '.$style.' '.$class.' src=\"".psConf::getURLPicturesShow('.$display_root_url.').$_ctx->psGallery->getRelativRep()."/".$_ctx->picture->getThumbnailByFormatId($_ctx->psGallery->getThumbnailsFormatId())->getFileName()."\" alt=\"".$_ctx->picture->getLabel()."\"/>";
					$code_html_href_et_img = sprintf($code_html_href,$code_html_img);
					echo '.sprintf($f,'$code_html_href_et_img').';
				}
			?>';
	}

	/**
	 * Donne l'url de l'image principale ou de la miniature.
	 * Si l'attribut thumbnails est à 1, c'est la miniature qui s'affiche.
	 */
	public static function pictureEntryURL($attr)
	{
		$display_root_url = "false";
		if(isset($attr["absolute_urls"]) && $attr["absolute_urls"] == "1") {
			$display_root_url = "true";
		}
		
		if(isset($attr["thumbnails"]) && $attr["thumbnails"]=="1") {
			return
			'<?php 
			if (psConf::getIfActif()) {
				echo psConf::getURLPicturesShow('.$display_root_url.').$_ctx->psGallery->getRelativRep()."/".$_ctx->picture->getThumbnailByFormatId($_ctx->psGallery->getThumbnailsFormatId())->getFileName();
			}?>';
		}
		else {
			return
			'<?php 
			if (psConf::getIfActif()) {
				echo psConf::getURLPicturesShow('.$display_root_url.').$_ctx->psGallery->getRelativRep()."/".$_ctx->picture->getThumbnailByFormatId($_ctx->psGallery->getFormatId())->getFileName();
			} ?>';
		}
	}
	
	/* Acces*************************/
	/**
	  * Donne url qui permet d'accéder à la galerie pour le post courant.
	   *
	   * $attr les attributs gérés sont :
	   * <ul>
	   * 	 <li>offset : -1 indique que le lien sera sur la page précédente de
	   * 	 	 la page courante,
	   * 	 +1 indique que le lien sera sur la page suivante de la page courante.</li>
	   * </ul>
	   */
	public static function galleryURL($attr)
	{
		$url = '';
		if (isset($attr['offset'])) {
			$offset = trim($attr['offset']);
		}
		if (isset($offset) && strlen($offset)>1) {
			if ($offset{0}=='+' || $offset{0}=='-') {
				$url = '".psConf::getURLPSGallery().$_ctx->posts->post_id."/".($_ctx->psGallery->getCurrentPageNum()'.$offset.')."/';
			}
			else {
				$url = '".psConf::getURLPSGallery().$_ctx->posts->post_id."/'.$offset.'/';
			}
		}
		else {
			$url = '".psConf::getURLPSGallery().$_ctx->posts->post_id."/';
		}

		return	'<?php 
				if (psConf::getIfActif()) {
					echo "'.$url.'";
				}?>';

	}
	
	
	/* Pagination
	 * Code fortement inspiré de dcTemplate ****************************/
	public static function pagination($attr,$content)
	{
		return '<?php 
		if (psConf::getIfActif() && $_ctx->psGallery->getNbPage() > 1) : ?>'.
			$content.'<?php 
		endif; ?>';
	}
	
	public static function paginationIf($attr,$content)
	{
		$if = array();
		
		if (isset($attr['start'])) {
			$sign = (boolean) $attr['start'] ? '' : '!';
			$if[] = $sign.'$_ctx->psGallery->getCurrentPageNum()==0';
		}

		if (isset($attr['end'])) {
			$sign = (boolean) $attr['end'] ? '' : '!';
			$if[] = $sign.'($_ctx->psGallery->getCurrentPageNum()==($_ctx->psGallery->getNbPage()-1))';
		}
		
		if (!empty($if)) {
			return '<?php if(psConf::getIfActif() && ('.implode(' && ',$if).')) : ?>'.$content.'<?php endif; ?>';
		} else {
			return '<?php if(psConf::getIfActif()) : ?>'.$content.'<?php endif; ?>';
		}
	}
	
	public static function paginationCurrent($attr)
	{
		return
		'<?php if(psConf::getIfActif()) {echo ($_ctx->psGallery->getCurrentPageNum()+1); } ?>';
	}
	
	public static function paginationCounter($attr)
	{
		return
		'<?php if(psConf::getIfActif()) {echo $_ctx->psGallery->getNbPage(); } ?>';
	}
}


#-----------------------------------------------------------
# Defines 'picturesShow' urlHandler
#-----------------------------------------------------------
$core->url->register('picturesShow','picturesShow','^picturesShow(/.+)?$',array('urlPicturesShow','picturesShow'));


class urlPicturesShow extends dcUrlHandlers
{
	protected static function serveDocument($tpl,$content_type='text/html',$http_cache=true,$http_etag=true)
	{
		$_ctx =& $GLOBALS['_ctx'];
		$core =& $GLOBALS['core'];
		
		$tpl_file = $core->tpl->getFilePath($tpl);
		
		if (!$tpl_file) {
			header('Content-Type: text/plain; charset=UTF-8');
			echo 'Unable to find template';
			exit;
		}
		
		if ($http_cache) {
			$GLOBALS['mod_files'][] = $tpl_file;
			http::cache($GLOBALS['mod_files'],$GLOBALS['mod_ts']);
		}
		
		header('Content-Type: '.$content_type.'; charset=UTF-8');
		$out = $core->tpl->getData($tpl);
		
		if ($http_cache && $http_etag) {
			http::etag($out,http::getSelfURI());
		}
		echo $out;
	}
	
	public static function picturesShow($args)
	{
		if (!psConf::getIfActif()) self::p404();
		/* traitement des arguments */
		if ($args == null) {
			self::p404();
		}
		else if( preg_match('#^/([0-9]+)/?$#',$args,$m) ) {
			$post_id=$m[1];
			$page = 0;
		}
		else if( preg_match('#^/([0-9]+)/([0-9]+)/?$#',$args,$m) ) {
			$post_id= $m[1];
			$page   = $m[2];
		}
		else {
			self::p404();    
		}
		
		/* recherche des informations */
		$_ctx =& $GLOBALS['_ctx'];
		$core =& $GLOBALS['core'];
		
		$core->blog->withoutPassword(false);
		
		$params = new ArrayObject();
		$params['post_id'] = $post_id;
		
		$_ctx->posts = $core->blog->getPosts($params);

		$core->blog->withoutPassword(true);
		
		if ($_ctx->posts->isEmpty())
		{
			# No entry
			self::p404();
		}

		$GLOBALS['_ps_page_number'] = $page;

		$post_id = $_ctx->posts->post_id;
		$post_password = $_ctx->posts->post_password;

		# Getting commenter informations from cookie
		if (!empty($_COOKIE['comment_info'])) {
			$c_cookie = unserialize($_COOKIE['comment_info']);
			foreach ($c_cookie as $k => $v) {
				$_ctx->comment_preview[$k] = $v;
			}
			$_ctx->comment_preview['remember'] = true;
		}
		
		# Password protected entry
		if ($post_password != '')
		{
			# Get passwords cookie
			if (isset($_COOKIE['dc_passwd'])) {
				$pwd_cookie = unserialize($_COOKIE['dc_passwd']);
			} else {
				$pwd_cookie = array();
			}
			
			# Check for match
			if ((!empty($_POST['password']) && $_POST['password'] == $post_password)
			|| (isset($pwd_cookie[$post_id]) && $pwd_cookie[$post_id] == $post_password))
			{
				$pwd_cookie[$post_id] = $post_password;
				setcookie('dc_passwd',serialize($pwd_cookie),0,'/');
			}
			else
			{
				self::serveDocument('password-form-gal.html','text/html',false);
				exit;
			}
		}
		
		self::serveDocument('picturesShow.html',$content_type='text/html',$http_cache=false);
	}
}

?>
