<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear Picture Show plugin.
# Copyright (c) 2008 Anne-Cécile Calvot. All rights reserved.
#
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# ***** END LICENSE BLOCK *****  

/*
 * Les droits existants :
 *  
 * super-admin : user_super = 1
 *
 *	administrateur						: admin
 *		gérer tous les billets et commentaires		: contentadmin
 *			gérer ses propres billets et commentaires	: usage
 *			publier des billets et des commentaires 	: publish
 *			supprimer des billets et des commentaires	: delete
 *		gérer les catégories					: categories
 *		gérer tous les media					: media_admin
 *			gérer ses propres media			: media
 *	gestion de la liste de liens					: blogroll
 * */ 
$g_core = &$GLOBALS['core'];
if (!defined('DC_CONTEXT_ADMIN')) { exit; }
if (!$g_core->auth->isSuperAdmin() ) { exit; }
if (psConf::hasToBeInit()) { http::redirect($p_url."&type=plugin&msg=".__('Pictures Show has been updated for this blog')); }

$display_tab = '';
$msg = '';
if (!empty($_GET['msg'])) $msg = $_GET['msg'];

if (!empty($_POST['reinitconfig']))
{
	try
	{
		psConf::cleanAllAndInstall();
		http::redirect($p_url."&type=plugin");
	}
	catch (Exception $e)
	{
		$g_core->error->add($e->getMessage());
	}
}

$active = psConf::getIfActif();
$meta_rep = psConf::getMetaRepName();

if (!empty($_POST['saveconfig'])) {
	try
	{
		$active = (empty($_POST['active']))?false:true;
		$meta_rep = (empty($_POST['meta_rep']))?$meta_rep:$_POST['meta_rep'];

		if (!preg_match( "/^\w+$/",$meta_rep)) {
			throw new Exception("The format of the metadata is incorect.");
		}
		
		psConf::setPluginConf($active, $meta_rep);
		$g_core->blog->triggerBlog();

		$msg = __('Configuration successfully saved').".";
		http::redirect($p_url."&type=plugin&msg=".$msg);
	}
	catch (Exception $e)
	{
		$g_core->error->add($e->getMessage());
	}
}

if (!empty($_GET['cpimg']))
{
	$display_tab = "modif1";
	if( $_GET['cpimg']=="1" ) {
		$source_file = dirname(__FILE__)."/../img/all_pictures.png";
		$dest_file = $g_core->blog->themes_path."/".$g_core->blog->settings->theme."/img/all_pictures.png";
	}
	else {
		$source_file = dirname(__FILE__)."/../img/gallery.gif";
		$dest_file = $g_core->blog->themes_path."/".$g_core->blog->settings->theme."/img/gallery.gif";
	}

	try {
	    if (copy($source_file,$dest_file))
	    {
				$msg .= __('File added successfully').".";
			}
			else
			{
				$g_core->error->add("File {$source_file} not successfully added in {$dest_file}.");
			}
	}
	catch (Exception $e)
	{
		$g_core->error->add($e->getMessage());
	}
}

$g_core->callBehavior("adminPsBeboreHtmlContent",$g_core,$_POST,$p_url,$msg,'psFormat');


?>
<html>
<head>
	<title><?php echo __('Pictures Show'); ?></title>
	<script type="text/javascript" src="js/jquery/jquery.pageTabs.js"></script>
		<script type="text/javascript">
		//<![CDATA[
		$(function() {
			$.pageTabs('<?php echo $display_tab; ?>');
		});

		//]]>
	</script>
</head>

<body>
<h2><?php echo html::escapeHTML($g_core->blog->name); ?> &gt; <?php echo __('Pictures Show'); ?></h2>
<?php if (!empty($msg)) echo '<p class="message">'.$msg.'</p>';?>
<div class="multi-part" id="params" title="<?php echo __('Parameters'); ?>">
  <!--h3><?php echo __('Parameters'); ?></h3-->
  <p>Avant d'activer le plugin veillez à ce qu'il ne manque rien et
  n'hésitez pas à regarder la documentation.</p>
  
  
	<fieldset>
		<legend><?php echo __('Prerequiste'); ?></legend>
		<p class="field">
		Extensions utilisées par Pictures Show :
		<ul>
			<li>Metadata	1.0.2 (Dotclear 2)</li>
		</ul>
		</p>
	</fieldset>
  
	<form method="post" action="plugin.php">
	<fieldset>
		<legend><?php echo __('Plugin activation'); ?></legend>
		<p class="field">
			<label class="classic"><?php echo form::checkbox('active', 1, $active); ?>&nbsp;
			<?php echo __('Activate Pictures Show');?>
			</label>
			</p>
			<p class="field">
				<label class="required" title="Champ obligatoire">
				Identifiant de la metaData : 
				<input type="text" size="30" name="meta_rep" id="meta_rep" maxlength="32" value="<?php echo $meta_rep; ?>"/>
				</label>
			</p>
		</p>
	</fieldset>
	<input type="hidden" name="p" value="picturesShow" />
	<input type="hidden" name="type" value="plugin" />
	<?php echo $g_core->formNonce(); ?>
	<input type="submit" name="saveconfig" value="<?php echo __('Save configuration'); ?>" />
	<input type="submit" name="reinitconfig" value="<?php echo __('Reinitialize configuration'); ?> *" /><br/>
	(* : cela implique les paramètres de la galerie)</form>
	<br/><br/>
	<form method="post" action="plugin.php">
	<input type="hidden" name="p" value="picturesShow"/>
	<input type="hidden" name="type" value="plugin" />

	<?php
	$g_core->callBehavior("adminPsAfterFielset",$g_core,"psFormat");
	?>

	</form>
</div>


<div class="multi-part" id="descr" title="<?php echo __('Description (fr)'); ?>">
  <!--h3><?php echo __('Description (fr)'); ?></h3-->

	<fieldset>
		<legend><?php echo __('Pictures Show'); ?></legend>
		<p>
		<b>Pictures Show</b> est un outil qui permet de rattacher une galerie à un billet
		et par conséquent d'illustrer ce dernier sans avoir à insérer les images
		dans le texte du billet.</p>
		<p>
		Une fois Pictures Show correctement paramétré, 
		l'illustration d'un billet se fait en deux ou trois étapes :
		<ul><li>Dans un premier temps il faut ajouter, dans le repertoire public,
		un répertoire contenant les images que l'on veut voir s'afficher,</li>
		<li>durant l'édition du billet, utiliser le menu déroulant pour choisir le répertoire (la galerie)
		et le rattacher au billet,</li>
		<li>et pour finir, optionnellement, 
		il est possible de sélectionner et d'ordonner les images dans
		le gestionnaire accessible dans le menu Blog
		par '<?php echo __('Pictures Show galleries'); ?>'.</li></ul>
		</p>
		<p>
		Il est donc possible d'utiliser <b>Pictures Show</b> sans avoir à modifier son thème.
		Cependant, si votre thème est particulier ou si les propositions d'affichage ne
		correspondent pas exactement à vos attentes, il est possible d'utiliser
		les tags fournis pour personnaliser votre affichage.<br />
		Pour faciliter la modification de votre thème,
		un exemple est fourni (cf. <?php echo __("Exemple d'utilisation des tags (fr)"); ?>).
		Il permet de mettre en place une présentation standard.
		</p>
	</fieldset>
	<fieldset>
		<legend><?php echo __('Rattacher une galerie'); ?></legend>
		<p>
		Dans le formulaire de création/modification d'un billet,
		un menu déroulant listant les galeries disponibles est rajoutée.
		</p>
		<p>
		Remarque : Pour pouvoir avoir accès au menu déroulant, il faut se connecter avec un utilisateur
		qui a des droits de publication (droits liés au plugin <b>Metadata</b>).
		</p>
		<p>
		Côté blog, il sera possible de visualiser toutes les images
		de la galerie ainsi créée.
		L'affichage de cette galerie varie en fonction des paramètres choisis dans le panneau d'administration
		'<?php echo __('Pictures Show galleries'); ?>'du blog.<br />
		</p>
	</fieldset>
	<fieldset>
		<legend><?php echo __('Créer et gérer une galerie'); ?></legend>
		<p>
		Une galerie est un ensemble d'images regroupées dans un même répertoire.
		Pour être pris en compte, ce répertoire doit se situer dans le répertoire public,
		c'est à dire dans le répertoire géré par le gestionnaire de média de Dotclear.
		Dans le paramétrage de <b>Pictures Show</b> on doit préciser 
		les deux formats d'affichage que l'on veut utiliser (l'image et sa miniature).
		Pour qu'une image puisse faire partie de la galerie, il faut qu'elle 
		possède les deux formats.
		Pour créer une galerie il suffit donc de créer un répertoire
		(via le gestionnaire de média par exemple) et d'y mettre les images que l'on veut voir s'afficher.
		</p>
		<p>
		<b>Pictures Show</b> rajoute un accès '<?php echo __('Pictures Show galleries'); ?>'
		dans le menu blog. Cet accès propose un onglet 
		'<?php echo __('Galleries Manager'); ?>'
		permettant de sélectionner et ordonner les images
		pour chacune des galeries disponibles.</p>
		<p>
		Pour avoir accès à une galerie il faut avoir le droit de gérer toutes les images qu'elle contient.
		</p>
	</fieldset>
	<fieldset>
		<legend><?php echo __('Affichage de la galerie'); ?></legend>
		<p>
		Pour l'affichage des images côté blog, <b>Pictures Show</b> propose différents
		types de présentation.		
		Le choix de la présentation se fait dans l'onglet
		'<?php echo __('Display parameters'); ?>'
		du panneau  '<?php echo __('Pictures Show galleries'); ?>)'
		proposé dans le menu Blog.
		</p>
		<p>
		Les possibilités d'affichage sont variées mais sont basées sur deux
		axes principaux. Le premier consiste à afficher la galerie
		en utilisant <b>la page de visualisation</b> proposée par Pictures Show.
		Pour ce faire il suffit de paramétrer le champ
		<b><?php echo __('Link target');?></b> 
		à <b><?php echo __('The Pictures Show page');?></b>
		et le champ <b><?php echo __('Content');?></b> à <b><?php echo __('Preview with 4 pictures (with points)');?></b>.
		Les autres paramètres permettant de faire varier quelques caractéristiques :
		<ul><li><b><?php echo __('Number of pictures per page');?></b> permet
		de choisir le nombre d'images que l'on veut voir s'afficher par page,</li>
		<li><b><?php echo __('Main format');?></b>
		permet de choisir des images grand format 
		<?php if($g_core->plugins->moduleExists(__("formatPlus")) === false) { ?>
		(parmis les formats proposés par dcMedia)
		<?php } else { ?>
		(parmis les formats précisés dans l'administration)
		<?php } ?>
		qui seront accessibles par un clic,</li>
		<li><b><?php echo __('Thumbnails format');?></b>
		permet de choisir le format des miniatures
		<?php if($g_core->plugins->moduleExists(__("formatPlus")) === false) { ?>
		(parmis ceux proposés par dcMedia)
			<?php } else { ?>
		(parmis ceux précisés dans l'administration)
		<?php } ?>
		qui seront effectivement affichés dans la page,</li>
		<li><b><?php echo __('Visible menu');?></b> permet de faire disparaitre
		le menu pour afficher des fomats plus grands,</li>
		<li><b><?php echo __('Link decoration');?></b> et 
		<b><?php echo __('Title aspect');?></b>
		permettent d'adapter la présentation au style du blog.</li>
		</ul>
		</p>
		<p>
		L'autre axe, consiste à mettre la galerie directement dans la
		page réservée au billet. Pour ce faire il suffit de paramétrer le champ
		<b><?php echo __('Link target');?></b>
		à <b><?php echo __('Gallery inside the post');?></b>
		et le champ <b><?php echo __('Content');?></b>
		à <b><?php echo __("Display the gallery (with 'Gallery aspect' parameter)");?></b>.
		Les autres paramètres permettant, là aussi, de faire varier quelques caractéristiques :
		<ul><li><b><?php echo __('Number of pictures per page');?></b> permet
		de choisir le nombre d'images que l'on veut voir s'afficher
		(il n'y a pas de système de pagination dans ce cas),</li>
		<li><b><?php echo __('Main format');?></b>
		permet de choisir des images grand format 
		<?php if($g_core->plugins->moduleExists(__("formatPlus")) === false) { ?>
		(parmi les formats proposés par dcMedia)
		<?php } else { ?>
		(parmis les formats précisés dans l'administration)
		<?php } ?>
		qui seront accessibles par un clic,</li>
		<li><b><?php echo __('Thumbnails format');?></b>
		permet de choisir le format des miniatures
		<?php if($g_core->plugins->moduleExists(__("formatPlus")) === false) { ?>
		(parmi ceux proposés par dcMedia)
			<?php } else { ?>
		(parmis ceux précisés dans l'administration)
		<?php } ?>
		qui seront effectivement affichés dans le billet,</li>
		<li><b><?php echo __('Link decoration');?></b> et 
		<b><?php echo __('Title aspect');?></b>
		permettent d'adapter la présentation au style du blog.</li>
		</ul>
		</p>
		<p>
		Il existe une liste de styles prédéfinis, cette liste permet
		de charger rapidement un exemple de configuration.
		</p>
		<p>
		Pour avoir accès à cet onglet il faut avoir les droits administrateur.
		</p>
	</fieldset>
	<fieldset>
		<legend><?php echo __('Administration du plugin'); ?></legend>
		<p>
		Pictures Show rajoute un accès (<?php echo __('Pictures Show'); ?>) dans le menu Extensions.
		Cet accès permet d'activer/désactiver l'extension et, en cas de conflit,
		de personnaliser l'identifiant de la méta-donnée utilisée
		pour sauvegarder le répertoire correspondant à la galerie.
		</p>
		<p>
		Pour avoir accès à ces informations il faut avoir les droits de super-utilisateur.
    </p>
	</fieldset>
</div>

<div class="multi-part" id="tags" title="<?php echo __('Tags (fr)'); ?>">
  <!--h3><?php echo __('Tags (fr)'); ?></h3-->
  <p>
		  L'extension comprend des tags qui permettent de personnaliser les
			différentes pages de votre thème.<br/>
      Lorsque l'extension est désactivée, pour ne pas polluer l'affichage,
      les tags ajoutés dans les pages du thème
      sont quand-même traités en n'affichant ni les tags, ni leur contenu.
  </p>
	<fieldset>
		<legend>{{tpl:GalleryURL}}</legend>
		<p>Donne l'url qui permet d'accéder à la galerie
		pour le billet courant.
		Si l'attribut n'est pas précisé l'url permet d'accèder à la premiére page de la galerie.</p>
		<p>
		Liste des attributs possibles :
		<ul>
		<li>
			<b>offset</b> : si l'offset est un chiffre, l'URL permet d'accéder à la (offset+1)ème page,<br/>
			si offset vaut -1, l'URL permet d'accéder à la page précédente de la page courante de la galerie,<br/>
			si offset vaut +1, l'URL permet d'accéder à la page suivante de la page courante.
		</li>
		</ul>
		</p>
	</fieldset>
	<fieldset>
		<legend>&lt;tpl:IfPicturesEntries&gt;</legend>
		<p>Le contenu ne s'affiche que s'il existe une galerie
		avec au moins une image qui possède les formats demandés.</p>
		<p>
		Liste des attributs possibles :
			<ul>
				<li><b>pictures_format</b> : Peut prendre comme valeur sq, t, s, m et o
					qui correspondent aux formats square, thumbail, small, medium et original
					du gestionnaire de médias
					<?php if($g_core->plugins->moduleExists(__("formatPlus")) === true) { ?>
					, il peut prendre aussi les formats utilisateur définis depuis l'administration
					<?php } ?>.<br />
					La valeur correspond au premier format dont ont vérifie l'existence.<br />
					Si l'attribut n'est pas mis, ce sera le format précisé dans l'interface d'administration
					qui sera choisi. Si la valeur est fausse rien ne s'affiche.
				</li>
				<li><b>thumbnails_format</b> : Peut prendre comme valeur sq, t, s, m et o
					qui correspond au format square, thumbail, small, medium et original
					du gestionnaire de médias
					<?php if($g_core->plugins->moduleExists(__("formatPlus")) === true) { ?>
					, il peut prendre aussi les formats utilisateur définis depuis l'administration
					<?php } ?>.<br />
					La valeur correspond au deuxième format dont ont vérifie l'existence.<br />
					Si l'attribut n'est pas mis, ce sera le format précisé dans l'interface d'administration
					qui sera choisi. Si la valeur est fausse, rien ne s'affiche.
				</li>
			</ul>
		</p>
		<p>
	</fieldset>
	<fieldset>
		<legend>&lt;tpl:PicturesEntries&gt;</legend>
		<p>Liste des images qui possèdent à la fois un format d'affichage (thumbnails_format)
		et un format principal (pictures_format).<br />
		{{tpl:PictureEntry}} permettra ensuite d'afficher les miniatures sous la forme de
		thumbnails_format, ces miniatures seront cliquables et afficheront le format principal.</p>
		<p>Les attributs influent sur le contenu qui sera listé.<br />
		Liste des attributs possibles :
		<ul>
			<li><b>no_content</b> : Si à 1, désactive le parcours (la boucle)
				sur les images, ce qui rend les attributs nb_pictures_per_page
				et randomize inopérants.</li>
			<li><b>pictures_format</b> : Peut prendre comme valeur sq, t, s, m et o
				qui correspondent aux formats square, thumbail, small, medium et original
				du gestionnaire de médias
				<?php if($g_core->plugins->moduleExists(__("formatPlus")) === true) { ?>
				, il peut prendre aussi les formats utilisateurs définis depuis
				l'administration
				<?php } ?>.<br />
				La valeur correspond au format d'image qui sera choisi pour
				les images principales (celui obtenu lorsque l'on clique sur la miniature).<br />
				Si l'attribut n'est pas mis, ce sera le format précisé dans l'interface d'administration
				qui sera choisi. Si la valeur est fausse, rien ne s'affiche.
			</li>
			<li><b>thumbnails_format</b> : Peut prendre comme valeur sq, t, s, m et o
				qui correspondent au format square, thumbail, small, medium et original
				du gestionnaire de médias
				<?php if($g_core->plugins->moduleExists(__("formatPlus")) === true) { ?>
				, il peut prendre aussi les formats utilisateurs définis depuis
				l'administration
				<?php } ?>.<br />
				La valeur correspond au format d'image qui sera choisi pour
				l'affichage des miniatures.
				Si la valeur est la même que pictures_format l'image ne se sera pas cliquable.<br />
				Si l'attribut n'est pas mis, ce sera le format précisé dans l'interface d'administration
				qui sera choisi. Si la valeur est fausse, rien ne s'affiche.
			</li>
			<li><b>nb_pictures_per_page</b> : le nombre d'images affichées par page.
			Si à -1, affiche toutes les images.</li>
			<li><b>randomize</b> : si à 1, affiche 'nb_pictures_per_page' images
				choisies aléatoirement.
			</li>
			<li><b>nb_pictures_min</b> : n'est actif que si le paramètre randomize est à 1.
				C'est le nombre minimum d'images que l'on veut voir s'afficher dans la galerie.
				Si la galerie possède moins d'images que le nombre indiqué alors certaines images seront dupliquées.
				Si la valeur est supérieure à nb_pictures_per_page alors l'attribut sera ignoré.
			</li>
		</ul>
		</p>
		<p>La possibilité d'utiliser les options pictures_format, thumbnails_format et nb_pictures_per_page,
		n'existe que pour permettre des affichages à but décoratif.
		Lorsque le but est d'afficher la galerie principale, il vaut mieux ne pas utiliser ces options
		et utiliser le paramétrage de l'administration.<br/>
		Lorsque qu'une des options pictures_format ou thumbnails_format est utilisée,
		il faut garder à l'esprit que 
		la liste des images peut différer de celle affichée sans
		les options, par exemple si des images n'existent pas sous tous les formats.
		</p>
	</fieldset>
	<fieldset>
		<legend>&lt;tpl:PicturesEntriesHeader&gt;</legend>
		<p>A positionner dans une balise &lt;tpl:PicturesEntries&gt;
		Le contenu ne sera affiché qu'à la première itération de la boucle.
		Ce qui permet d'afficher un en-tête de la liste d'images sans utiliser
		&lt;tpl:IfPicturesEntries&gt;.</p>
	</fieldset>
	<fieldset>
		<legend>&lt;tpl:PicturesEntriesFooter&gt;</legend>
		<p>A positionner dans une balise &lt;tpl:PicturesEntries&gt;
		Le contenu ne sera affiché qu'à la dernière itération de la boucle.
		Ce qui permet d'afficher un pied de page à la liste d'images sans utiliser
		&lt;tpl:IfPicturesEntries&gt;.</p>
	</fieldset>
	<fieldset>
		<legend>{{tpl:PictureEntry}}</legend>
		<p>
			A positionner dans une balise &lt;tpl:PicturesEntries&gt;.<br />
			Affiche l'image courante de la boucle.
		</p>
		<p>Les attributs influent sur l'apparence de l'image, et son statut cliquable.<br />
			Liste des attributs possibles :
			<ul>
				<li><b>style</b> : Permet de préciser le style CSS à appliquer à l'image</li>
				<li><b>class</b> : Permet de préciser la classe CSS à appliquer à l'image</li>
				<li><b>link</b> : Peut prendre comme valeur "sq", "t", "s", "m" et "o"
					qui correspondent au format square, thumbail, small, medium et original
					du gestionnaire de médias
					<?php if($g_core->plugins->moduleExists(__("formatPlus")) === true) { ?>
					, il peut également prendre les formats utilisateur définis depuis
					l'administration
					<?php } ?>.<br />
					La valeur correspond au format de l'image qui s'affiche lorsque l'on
					clique sur l'image.<br />
					Si le format est vide on utilisera le format original,
					s'il n'existe pas, on n'affiche pas de lien.
				</li>
			</ul>
		</p>
	</fieldset>
	<fieldset>
		<legend>{{tpl:PictureEntryURL}}</legend>
		<p>
			A positionner dans une balise &lt;tpl:PicturesEntries&gt;.<br />
			Affiche l'URL de l'image principale courante de la boucle.<br />
			Liste des attributs possibles :
			<ul>
				<li><b>thumbnails</b> : Si à 1, affiche l'URL de la miniature (l'image cliquable) à la place de
				l'image principale.</li>
			</ul>
		</p>
	</fieldset>
	<fieldset>
		<legend>{{tpl:PictureIf}}</legend>
		<p>A positionner dans une balise &lt;tpl:PicturesEntries&gt;.
		</p>
		<p>Liste des attributs possibles :
			<ul>
				<li><b>first</b> : si possède une valeur, la retourne si l'on est
				dans la première occurence de la boucle, donc en train d'afficher
				la première image.</li>
				<li><b>last</b> : si possède une valeur, la retourne si l'on est
				dans la dernière occurence de la boucle, donc en train d'afficher
				la dernière image.</li>
			</ul>
		</p>
	</fieldset>
	<fieldset>
		<legend>&lt;tpl:PicturesPagination&gt;</legend>
		<p>Si l'on a plusieurs pages, le contenu compris entre les balises s'affiche.<br />
		Il ne s'agit pas d'une boucle sur les pages.
		</p>
	</fieldset>
	<fieldset>
		<legend>&lt;tpl:PicturesPaginationIf&gt;</legend>
		<p>Affiche le contenu en fonction des valeurs des attributs.
		Il faut que toutes les conditions exprimées au travers des attributs
		soient remplies pour que le contenu s'affiche.
		</p>
		<p>Liste des attributs possibles :
			<ul>
				<li><b>start</b> : si vaut 1, il faut être sur la première page pour
				que le contenu s'affiche<br />
				si vaut 0, il faut ne pas être sur la première page pour
				que le contenu s'affiche</li>
				<li><b>end</b> : si vaut 1, il faut être sur la dernière page pour
				que le contenu s'affiche<br />
				si vaut 0, il faut ne pas être sur la dernière page pour
				que le contenu s'affiche</li>
			</ul>
		</p>
	</fieldset>
	<fieldset>
		<legend>{{tpl:PicturesPaginationCurrent}}</legend>
		<p>Affiche le numéro de page courante.<br />
		La numérotation commence à 1.
		</p>
	</fieldset>
	<fieldset>
		<legend>{{tpl:PicturesPaginationCounter}}</legend>
		<p>Affiche le nombre de pages.
		</p>
	</fieldset>
</div>

<div class="multi-part" id="modif1" title="<?php echo __("Exemple d'utilisation des tags (fr)"); ?>">
  <!--h3><?php echo __("Exemple d'utilisation des tags (fr)"); ?></h3-->
  <p>
	Sous Dotclear2 pour apporter les modifications à un thème il suffit d'utiliser
	l'éditeur de thème fournit par Dotclear.
	Toutefois, si le thème est Blowup, quelques précautions s'imposent
	(cf. "Personnaliser le theme au-delà de la configuration automatisée"
	de la documentation officielle 
	<a href="http://fr.dotclear.org/documentation/2.0/admin/themes/blowup">ici</a>)
  </p>
  <p>
	Les modifications suivantes ont été pensées pour le thème 'Blue Silence'
	mais doivent fonctionner avec un thème de style 'Blowup'.<br />
	En cas de multiblog partageant le même répertoire de thème, les modifications d'un thème
	n'apparaiteront que pour les blogs ayant activés le plugin (cf. Tags). 
	Par conséquent l'ajout expliqué ici n'aura pas d'influence sur les autres blogs
	que le blog courant.
  </p>
	<fieldset>
		<legend><?php echo __('Goals'); ?></legend>
		<p>Dans l'exemple décrit ici l'objectif est de construire la 
		même galerie que celle proposée par défaut par Pictures Show
		mais cette fois-ci en la construisant par tag.
		Le blog proposera donc un accès à la galerie soit depuis la page d'accueil,
		soit depuis la page dédiée au billet. De plus la galerie permettra de
		visualiser les images en grand format.
		</p>
	</fieldset>
	
	<fieldset>
		<legend><?php echo __('The context file'); ?> home.html</legend>
		<p>
		Pour accéder à la galerie de Pictures Show, ce dernier fournit le tag
		{{tpl:GalleryURL}} qui va se charger de trouver, pour le billet courant,
		l'URL du lien vers sa galerie.<br />
		Le reste du code proposé ici est uniquement écrit dans un but visuel.
	  </p>
	  <p>
    Dans la page home, pour faire apparaître le lien à gauche des commentaires et des rétroliens,
		il faut procéder aux modifications suivantes :
    <ol>
      <li>Dans le fichier 'home.html' du thème,
          avant &lt;tpl:EntryIf show_comments="1"&gt;, ajouter les lignes suivantes&nbsp;:<br />
          <code>
          &lt;tpl:IfPicturesEntries&gt;<br />
          &lt;a href="{{tpl:GalleryURL}}" class="all_photo"&gt;{{tpl:lang see the gallery}}&lt;/a&gt;<br />
          &lt;/tpl:IfPicturesEntries&gt;<br />
          </code>
      </li>
      <li>Ajouter les lignes suivantes au fichier 'style.css' du thème&nbsp;:<br />
        	<code>
		.all_photo {<br />
        	&nbsp;&nbsp;background: url('img/all_pictures.png') no-repeat 0 50%;<br />
        	}<br />
        	</code>
      </li>
      <li>Ajouter l'image all_pictures.png au répertoire img de votre thème :<br />
        <img alt="" src="index.php?pf=picturesShow/img/all_pictures.png" />
				(clic droit, enregistrer; ne pas oublier de renommer le ficher; puis ftp).
      </li>
    </ol>
    </p>
    <p><b>Astuce : </b>Pour créer le fichier 'all_pictures.png' dans le thème courant
		(<?php echo $g_core->blog->settings->theme;?>)
		et donc dans le répertoire
		<code>
		<?php echo $g_core->blog->themes_path."/".$g_core->blog->settings->theme."/img";?>
		</code>, <a href="plugin.php?p=picturesShow&type=plugin&cpimg=1">cliquez ici</a>.
    </p>
		<p><b>Astuce Thème style Blowup : </b>Pour un meilleur rendu, au lieu d'utiliser
		l'image précédente, il est possible d'utiliser le fichier 'gallery.gif'
		<img alt="" src="index.php?pf=picturesShow/img/gallery.gif" />
		(proposé par Paul Armstrong en licence GNU).
		Pour créer le fichier 'gallery.gif' dans le thème courant
		(<?php echo $g_core->blog->settings->theme;?>)
		et donc dans le répertoire
		<code>
		<?php echo $g_core->blog->themes_path."/".$g_core->blog->settings->theme."/img";?>
		</code>, <a href="plugin.php?p=picturesShow&type=plugin&cpimg=2">cliquez ici</a>.<br />
		Attention à mettre le css à jour.
    </p>
    <p>
     Si vous allez voir un billet rattaché à une galerie, voici les
	modifications attendues dans la barre qui suit le contenu du billet :<br />
      <img alt="" src="index.php?pf=picturesShow/img/home_avant_apres.png" />
    </p>
	</fieldset>

	<fieldset>
		<legend><?php echo __('The context file'); ?> post.html</legend>
		<p>
			Dans le billet on va afficher la galerie en miniature, celle-ci étant un immense
			lien vers la véritable galerie.
			<ul>
				<li>
				Pour afficher le lien {{tpl:GalleryURL}} est encore une fois utilisé.
				</li>
				<li>
				&lt;tpl:PicturesEntries pictures_format="sq" thumbnails_format="sq" nb_pictures_per_page="-1"&gt;
				va parcourir toutes les images de la galerie et les afficher au format square (sq).
				</li>
				<li>
				{{tpl:PictureEntry class="pictures"}} permet d'afficher
				l'image tel que défini avec &lt;tpl:PicturesEntries&gt;.
				</li>
			</ul>
		</p>
	  <p>
	    Dans la page du billet, pour mettre un aperçu complet de la galerie,
	    il faut procéder aux modifications suivantes&nbsp;:
    <ol>
      <li>Dans le fichier 'post.html' du thème,
          avant <code>&lt;!-- # Comments --&gt;</code>, ajouter les lignes suivantes&nbsp;:<br />
            <code>
				&lt;!-- pictures --&gt;<br />
				&lt;tpl:IfPicturesEntries&gt;<br />
				&lt;div id="pictures"&gt;<br />
				&lt;h3&gt;{{tpl:lang The gallery}}&lt;/h3&gt;<br />
				&lt;div id="pictures-div"&gt;<br />
				&lt;a href="{{tpl:GalleryURL}}"&gt;<br />
				&lt;p class='see_gallery'&gt;{{tpl:lang see the gallery}}&lt;/p&gt;<br />
				&lt;tpl:PicturesEntries pictures_format="sq" thumbnails_format="sq"  nb_pictures_per_page="-1"&gt;<br />
				&lt;div class='picture-div {{tpl:PictureIf last="last"}}'&gt;<br />
				{{tpl:PictureEntry}}<br />
				&lt;/div&gt;<br />
				&lt;/tpl:PicturesEntries&gt;<br />
				&lt;/a&gt;<br />
				&lt;/div&gt;&lt;p style='clear: left;'&gt;&nbsp;&lt;/p&gt;<br />
				&lt;/div&gt;<br />
				&lt;/tpl:IfPicturesEntries&gt;<br />
					  </code>
      </li>
      <li>Au fichier 'style.css' du thème à l'endroit où se trouve <code>#comments h3</code>
			modifier la ligne de la manière suivante&nbsp;:<br />
      <code>
			#pictures, #comments, #pings { padding-top: 10px; }<br />
      </code>
      </li>
      <li>Au fichier 'style.css' du thème, <b>devant</b> <code>#comments h3</code>
			ajouter le texte <code>#pictures h3, </code>.
			</li>
			<li>Au fichier 'style.css' du thème après la ligne
			<code>#pictures h3, #comments h3,</code>[...]
			rajouter/modifier la ligne suivante&nbsp;:<br />
			<code>
				&nbsp;&nbsp;&nbsp;clear: both;<br />
			</code>
			</li>
			<li>Dans le fichier 'style.css' rajouter les lignes suivantes&nbsp;:<br />
			<code>
			/* contien image + texte */<br />
			.pictures-div {<br />
			&nbsp;&nbsp;margin: 0 0 0 0;<br />
			&nbsp;&nbsp;width: 300px;<br />
			}<br />
			#pictures a {<br />
			&nbsp;&nbsp;padding: 0px 0px 0px 18px;<br />
			}<br />
			<br />
			&nbsp;&nbsp;#pictures a:link, #pictures a:visited {<br />
			&nbsp;&nbsp;&nbsp;&nbsp;text-decoration: none;<br />
			&nbsp;&nbsp;}<br />
			<br />
			/* partie texte */<br />
			#pictures p.see_gallery {<br />
			&nbsp;&nbsp;background: url('img/all_pictures.png') no-repeat 0 50%;<br />
			&nbsp;&nbsp;margin: 0px 0 1em 0;<br />
			&nbsp;&nbsp;padding: 0 0 0 18px;<br />
			}<br />
			<br />
			/* partie image */<br />
			div.picture-div {<br />
			&nbsp;&nbsp;margin: 0pt 10px 10px 0pt;<br />
			&nbsp;&nbsp;padding: 0px;<br />
			&nbsp;&nbsp;float: left;<br />
			&nbsp;&nbsp;width: 48px;<br />
			&nbsp;&nbsp;height: 48px;<br />
			}<br />
			&nbsp;&nbsp;.last  {<br />
			&nbsp;&nbsp;&nbsp;&nbsp;margin: 0pt 10px 40px 0pt;<br />
			&nbsp;&nbsp;}<br />
			<br />
 		 </code>
      </li>
    </ol>
    </p>
    <p>
      Si le billet est rattaché à une galerie, voici le résultat obtenu :<br />
      <img alt="" src="index.php?pf=picturesShow/img/post.png" />;
    </p>
	</fieldset>
	
	<fieldset>
		<legend><?php echo __('The context file'); ?> picturesShow.html</legend>
		<p>
		Pour la visualisation des images, Pictures Show fournit un template
		simple (picturesShow.htm) basé sur le thème 'Blue Silence'.
		Il est bien entendu possible de personaliser cette page via
		l'éditeur de thème de Dotclear ou en rajoutant manuellement
		la page 'picturesShow.html' dans le thème choisi pour le blog
		en cours, et ainsi créer votre propre galerie en utilisant
		les différents tags (cf. Tags).<br />
		Il est tout de même possible de personnaliser un minimum l'affichage
		de ce contexte sans avoir à toucher au fichier
		(cf. <?php echo __('Description (fr)'); ?>).
		</p>
		<p>
		Dans notre exemple on utilise les paramètres suivant :
		<ul>
			<li>
			<?php echo __('Number of pictures per page'); ?> : 5
			</li>
			<li>
			<?php echo __('Main format'); ?> : <?php echo "--".__("Original")."--"; ?>
			</li>
			<li>
			<?php echo __('Thumbnails format'); ?> : <?php echo "--".__("Original")."--" ?><br />
			Si les dimensions de l'image originale sont trop grandes
			pour s'insérer correctement dans le blog, il est possible,
			en changeant cette valeur,
			d'afficher le format medium du gestionnaire de média.
			Comme '<?php echo __('Main format'); ?>' est à
			<?php echo "--".__("Original")."--"; ?>
			l'image medium sera cliquable et affichera l'original.
			</li>
			<li>
			<?php echo __('Visible menu'); ?> : décochée,
			Efface le menu de droite (ou gauche), ce qui permet de gagner en place d'affichage.
			</li>
			<li><?php echo __('Link target');?>
			et <?php echo __('Content');?> : "--<?php echo __('None');?>--",
			ce qui désactive l'ajout automatique de tag.</li>
    </ul>
    </p>
	</fieldset>
</div>

</body>
</html>
